import logging

from paircd.client import Client
from paircd.command_handler import CommandHandler
from paircd.message import Message
from paircd.server import Server


class UserHandler(CommandHandler):
    def __init__(self) -> None:
        super().__init__("USER", 4)

    async def handle(self, server: Server, client: Client, msg: Message) -> None:
        if client.registered:
            client.log("USER issued after registration", level=logging.WARN)
            return

        client.username = msg.args[0]
        client.realname = msg.args[3]

        if client.nickname:
            client.registered = True
            client.log("registered")
